//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <ipl.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

bool acabar= false;

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // 1. Abrir la fuente de vdeo
  CvCapture *cap= NULL;
  acabar= false;
  // 1.1. De cmara
  if (RadioButton1->Checked) {
    cap= cvCaptureFromCAM(-1);
  }
  // 1.2. O de archivo AVI
  else {
    if (OpenDialog1->Execute())
      cap= cvCaptureFromAVI(OpenDialog1->FileName.c_str());
    else
      return;
  }
  if (!cap) {
    if (RadioButton1->Checked)
      ShowMessage("No se puede encontrar ninguna cmara.");
    else
      ShowMessage("El archivo no se encuentra o no es un AVI vlido.");
    return;
  }

  // 2. Crear el detector de caras
  CvHaarClassifierCascade* cascade= (CvHaarClassifierCascade*)
    cvLoad("C:\\Archivos de programa\\OpenCV\\data\\haarcascades\\haarcascade_frontalface_default.xml");
  if (!cascade) {
    ShowMessage("No se puede abrir un archivo de OpenCV.");
    cvReleaseCapture(&cap);
    return;
  }
  CvMemStorage *storage = cvCreateMemStorage(0);
  CvSeq *faces;
  IplImage *img= cvQueryFrame(cap);
  IplImage *cop= cvCloneImage(img);
  cop->origin= 0;

  // 3. Para cada frame, hasta que se acabe el vdeo o se pulse una tecla
  while (img && cvWaitKey(1)==-1 && !acabar) {
    // 3.1. Copiar la imagen en top-left
    if (img->origin==0)
      cvCopy(img, cop);
    else
      cvFlip(img, cop);
    img->origin= 0;
    cvNamedWindow("Entrada", 0);
    cvShowImage("Entrada", cop);
    Application->ProcessMessages();
    // 3.2. Detectar las caras en la imagen
    faces= cvHaarDetectObjects(cop, cascade, storage);
    // 3.3. Para cada cara encontrada, pintar un rectngulo negro
    for (int i= 0; i<faces->total; i++ && !acabar) {
      CvRect rect= *(CvRect*)cvGetSeqElem(faces, i);
      cvRectangle(cop,
          cvPoint(rect.x+rect.width*0.1, rect.y+rect.height*0.25),
          cvPoint(rect.x+rect.width*0.9, rect.y+rect.height*0.55),
          CV_RGB(0,0,0), -1);
    }
    // 3.4. Mostrar el resultado
    cvNamedWindow("Salida", 0);
    cvShowImage("Salida", cop);
    img= cvQueryFrame(cap);
  }

  // 4. Acabar liberando memoria
  cvReleaseCapture(&cap);
  cvReleaseImage(&cop);
  cvReleaseMemStorage(&storage);
  cvReleaseHaarClassifierCascade(&cascade);
}
//---------------------------------------------------------------------------
 
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

